
	jQuery.fn.shoddyGraph = function(){

		// Slap an "Add" button next to the graph textbox:
		$('<a href="#" class="addGraphButton">+</a>')
			.insertAfter(this)
			.click(function(){
				//$(this).prev("INPUT").andSelf().next("BR").andSelf().clone(true).insertAfter(this).eq(0).trigger("focus").trigger("select");
				$(this).parent()
					.clone(true).insertAfter( $(this).parent() )
					.children(".hasGraph").trigger("focus").trigger("select").trigger("keyup");
				return false;
			});


		$(this).addClass("hasGraph")

			// Filter for specific keys:
			.keypress(function(e){

				// Hitting Enter triggers the addGraphButton:
				if( e.keyCode == 13 ){
					$(this).siblings(".addGraphButton").trigger("click");
					return false;
				};

				// Return false to cancel the event if user is not pressing number keys:
				return /[0-9]/.test( String.fromCharCode(e.keyCode) );
			})

			// Re-plot all graphs after every keystroke:
			.keyup(function(){

				// Fetch array of all the graph textboxes:
				var $textboxes = $(this).parent("LI").siblings().children("INPUT.hasGraph").add(this);

				// Derive the largest number that has been typed into the boxes: (We'll use this as our 100% value)
				var max = $.map( $textboxes, function(textbox){ return parseFloat( $(textbox).val() ) || 0 } ).sort().pop();
				//var max = 0; $textboxes.each(function(){ max = Math.max( max, parseFloat( $(this).val() ) || 0 ); });
				//var sum = 0; $textboxes.each(function(){ sum += parseFloat( $(this).val() ) || 0; });

				$textboxes.each(function(){

					var val		= parseFloat( $(this).val() ) || 0;
					var percent	= ( 100 * val / max ) + "%";
					var imgPos	= -200 + ( $(this).width() * val / max );

					$(this)
						.trigger("beforeReplot")
						.attr({ title : percent })
						.css({ backgroundPositionX : imgPos })
						.trigger("afterReplot");

				});

			})
		;


		// Add a custom class name to the label element associated with the textbox:
		$("LABEL[for=" + this.attr("id") + "]").addClass("graphLabel").length;


		// Handle click on the labels:
		$("LABEL.graphLabel").live("click", function(){
			
			var $label = $(this);
			var $labelBox = $('<input type="text" class="graphLabel"/>')
				.val( $(this).text() )
				.hide()
				.insertAfter(this)
				.keydown(function(e){
					if( e.keyCode==13 ){
						$label
							.text( $(this).hide("fast").val() )
							.show("fast")
							//.siblings("INPUT.hasGraph")
							//	.focus().select();
					}
				})
				.show("fast", function(){ $(this).focus().select() });

			$label.hide("fast");
			
		});

	};
